package com.muyu.vehicle.core;

import com.muyu.domain.Vehicle;
import com.muyu.vehicle.model.VehicleData;
import com.muyu.vehicle.model.VehicleInstance;

import java.util.HashMap;
import java.util.Map;

/**
 * @author DongZl
 * @description: 车辆容器
 * @Date 2023-11-16 下午 02:30
 */
public class LocalContainer {

    /**
     * 车辆容器
     */
    public static final Map<String, VehicleInstance> vehicleDataMap = new HashMap<>();

    /**
     * 添加车辆
     * @param vehicle 车辆信息
     */
    public static void setVehicle(Vehicle vehicle){
        String vin = vehicle.getVin();
        VehicleInstance vehicleInstance = vehicleDataMap.get(vin);
        if (vehicleInstance == null){
            vehicleDataMap.put(vin,
                    VehicleInstance.builder()
                            .vehicleData(VehicleData.vehicleBuild(vehicle))
                            .vehicle(vehicle)
                            .build()
                    );
        }
    }

}
