package com.muyu.vehicle.model;

import com.muyu.domain.Vehicle;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import static java.lang.Thread.sleep;

/**
 * @author DongZeLiang
 * @version 1.0
 * @description 车辆实例
 * @date 2023/11/16
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class VehicleInstance {

    /**
     * 车辆
     */
    private Vehicle vehicle;


    /**
     * 实例数据
     */
    private VehicleData vehicleData;


    public static void main(String[] args) throws InterruptedException {


        Thread thread = new Thread(() -> {
            while (true){
                try {
                    sleep(1000);
                } catch (InterruptedException e) {
                    throw new RuntimeException(e);
                }
                System.out.println(System.currentTimeMillis());
            }
        });
        thread.start();

        new Thread(() -> {
            try {
                sleep(5000);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            System.out.println("执行了五秒，等待五秒，在开始");
            try {
                synchronized (thread){
                    thread.wait();
                }
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            System.out.println("等待了五秒，现在开始，3秒后杀死");
            synchronized (thread){
                thread.notify();
            }
            try {
                sleep(3000);
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
            synchronized (thread){
                thread.interrupt();
            }
            System.out.println("停止成功" + thread.isAlive());
        }).start();
    }

}
